/* display.h -- display headers */

/* includes */
#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ioctl.h>
#include <ncurses.h>

/* defines */
#define D_SUCCESS 1
#define D_ERROR -1
#define D_INV_STRING_LEN -2

#define MAX_TERM_STRING 64

#define CENTERED (1<<0)
#define LEFT (1<<1)
#define RIGHT (1<<2)

/* display specific variables */
typedef struct s_display {
  int outfd;
  int max_x;
  int max_y;
  char *screen;
} t_display;

/* function prototypes */
int display_init(t_display *display,int outfd);
int display_draw(t_display *display);
int display_draw_until_line(t_display *display,int line);
int display_set_cursor(t_display *display,int x,int y);
int display_clear_screen(t_display *display);
int display_shutdown(t_display *display);
int display_line(t_display *display,int X,int Y,int X_,int Y_,char sym);
int display_hor_line(t_display *display,int Y,char sym);
int display_string(t_display *display,int x,int y,char *string,int len);
int display_string_vert(t_display *display,int x,int y,char *string,int len);

